'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Btn = exports.IconText = exports.DEFAULT_THEME = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_THEME = exports.DEFAULT_THEME = { color: '#FFF', background: '#26a69a', hover: '#2bbbad' };

var IconText = exports.IconText = function IconText(_ref) {
    var text = _ref.text,
        icon = _ref.icon;
    return _react2.default.createElement(
        'span',
        null,
        icon ? _react2.default.createElement('span', { className: icon }) : null,
        text ? _react2.default.createElement(
            'span',
            null,
            text
        ) : null
    );
};

IconText.propTypes = {
    icon: _react.PropTypes.string,
    text: _react.PropTypes.string
};

var SCHEMES = {
    default: 'default',
    primary: 'primary',
    success: 'success',
    warning: 'warning',
    danger: 'danger'
};

var isScheme = function isScheme(schemeToCompare, propsScheme, disabled) {
    return propsScheme === schemeToCompare && !Boolean(disabled);
};

var createClassnames = function createClassnames(props) {
    var scheme = props.scheme,
        disabled = props.disabled;


    return (0, _classnames2.default)('rui-btn', {
        'rui-btn-default': isScheme(SCHEMES.default, scheme, disabled),
        'rui-btn-primary': isScheme(SCHEMES.primary, scheme, disabled),
        'rui-btn-success': isScheme(SCHEMES.success, scheme, disabled),
        'rui-btn-warning': isScheme(SCHEMES.warning, scheme, disabled),
        'rui-btn-danger': isScheme(SCHEMES.danger, scheme, disabled)
    });
};

var Btn = exports.Btn = function (_React$Component) {
    _inherits(Btn, _React$Component);

    function Btn(props) {
        _classCallCheck(this, Btn);

        var _this = _possibleConstructorReturn(this, (Btn.__proto__ || Object.getPrototypeOf(Btn)).call(this, props));

        _this.dispatchOnClick = function (e) {
            if (_this.props.onClick) {
                _this.props.onClick(e, _this.props.value);
            }
        };

        _this.state = { hovered: false };
        return _this;
    }

    _createClass(Btn, [{
        key: 'render',
        value: function render() {
            var props = this.props;

            var children = props.children,
                disabled = props.disabled,
                scheme = props.scheme,
                style = props.style,
                icon = props.icon,
                text = props.text,
                rest = _objectWithoutProperties(props, ['children', 'disabled', 'scheme', 'style', 'icon', 'text']);

            var classNames = createClassnames(props);

            return _react2.default.createElement(
                'button',
                _extends({}, rest, { disabled: disabled, onClick: this.dispatchOnClick,
                    ref: 'btn', className: classNames,
                    style: style, onMouseOver: this.onMouseOver, onMouseOut: this.onMouseOut }),
                children ? children : _react2.default.createElement(IconText, { icon: icon, text: text })
            );
        }
    }]);

    return Btn;
}(_react2.default.Component);

Btn.propTypes = {
    disabled: _react.PropTypes.bool,
    style: _react.PropTypes.object,
    icon: _react.PropTypes.string,
    text: _react.PropTypes.string,
    scheme: _react.PropTypes.string,
    onClick: _react.PropTypes.func,
    children: _react.PropTypes.node,
    value: _react.PropTypes.string
};
Btn.defaultProps = {
    scheme: SCHEMES.default,
    disabled: Boolean(false)
};