'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.FlexRow = exports.FlexColumn = exports.Flex = exports.SectionItem = exports.NavItem = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NavItem = exports.NavItem = function NavItem(_ref) {
    var background = _ref.background,
        flex = _ref.flex,
        children = _ref.children,
        style = _ref.style;
    return _react2.default.createElement(
        'nav',
        { role: 'navigation', style: _extends({ background: background, flex: flex || '0 1 auto' }, style) },
        children
    );
};

NavItem.propTypes = {
    flex: _react.PropTypes.string,
    children: _react.PropTypes.node,
    style: _react.PropTypes.object,
    background: _react.PropTypes.string
};

var SectionItem = exports.SectionItem = function SectionItem(_ref2) {
    var background = _ref2.background,
        flex = _ref2.flex,
        children = _ref2.children;
    return _react2.default.createElement(
        'section',
        { style: { background: background, flex: flex || '1 1' } },
        children
    );
};

SectionItem.propTypes = {
    background: _react.PropTypes.string,
    flex: _react.PropTypes.string,
    children: _react.PropTypes.node
};

var Flex = exports.Flex = function Flex(_ref3) {
    var className = _ref3.className,
        style = _ref3.style,
        children = _ref3.children;
    return _react2.default.createElement(
        'div',
        { className: className, style: _extends({ display: 'flex' }, style) },
        children
    );
};
var FlexColumn = exports.FlexColumn = function FlexColumn(props) {
    return _react2.default.createElement(
        Flex,
        { className: props.className, style: { flexDirection: 'column' } },
        props.children
    );
};
var FlexRow = exports.FlexRow = function FlexRow(props) {
    return _react2.default.createElement(
        Flex,
        { className: props.className, style: { flexDirection: 'row' } },
        props.children
    );
};

Flex.propTypes = {
    children: _react.PropTypes.node,
    style: _react.PropTypes.object,
    className: _react.PropTypes.string
};

FlexColumn.propTypes = {
    children: _react.PropTypes.node,
    className: _react.PropTypes.string
};

FlexRow.propTypes = FlexColumn.propTypes;