'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.divWith = exports.elementWith = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _identity = require('fkit-js/identity');

var _identity2 = _interopRequireDefault(_identity);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var elementWith = function elementWith(el) {
    return function (_ref) {
        var _ref$className = _ref.className,
            className = _ref$className === undefined ? '' : _ref$className,
            _ref$style = _ref.style,
            style = _ref$style === undefined ? {} : _ref$style,
            _ref$attrs = _ref.attrs,
            attrs = _ref$attrs === undefined ? {} : _ref$attrs;
        return function (props) {
            var _props$className = props.className,
                propClass = _props$className === undefined ? '' : _props$className,
                _props$style = props.style,
                propStyle = _props$style === undefined ? {} : _props$style,
                children = props.children,
                others = _objectWithoutProperties(props, ['className', 'style', 'children']); //eslint-disable-line


            var mergeStyles = _extends({}, propStyle, style);
            var attributes = _extends({}, others, attrs);
            var clsArr = [propClass, className].filter(_identity2.default);
            var clsName = clsArr.length > 0 ? clsArr.join(' ') : null;
            var propsToPass = _extends({ className: clsName, style: mergeStyles }, attributes);
            return _react2.default.createElement(el, propsToPass, children);
        };
    };
};

//helper
exports.elementWith = elementWith;
var divWith = exports.divWith = elementWith('div');

exports.default = elementWith;