'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.withStore = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * A poor mans store
 */
//withStore :: ( Obj -> Obj -> Obj ) -> Obj  -> (Component -> Component)
var withStore = exports.withStore = function withStore(reducer, initialState) {
    return function (Comp) {
        var _class, _temp, _initialiseProps;

        return _temp = _class = function (_Component) {
            _inherits(_class, _Component);

            function _class(props) {
                _classCallCheck(this, _class);

                var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));

                _initialiseProps.call(_this);

                _this.state = initialState;

                //create store shape
                var getState = _this.getState;
                var dispatch = _this.dispatch;

                _this.store = { getState: getState, dispatch: dispatch };
                return _this;
            }

            _createClass(_class, [{
                key: 'componentDidUpdate',
                value: function componentDidUpdate() {
                    //we can call notification here
                }
            }, {
                key: 'render',
                value: function render() {
                    return _react2.default.createElement(Comp, _extends({}, this.state, { store: this.store }));
                }
            }]);

            return _class;
        }(_react.Component), _initialiseProps = function _initialiseProps() {
            var _this2 = this;

            this.getState = function () {
                return _this2.state;
            };

            this.dispatch = function (fsa) {
                var dispatch = _this2.dispatch,
                    setState = _this2.setState,
                    getState = _this2.getState;

                dispatchAction({ dispatch: dispatch, setState: setState, getState: getState, reducer: reducer }, fsa);
            };
        }, _temp;
    };
};

var dispatchAction = function dispatchAction(_ref, fsa) {
    var dispatch = _ref.dispatch,
        setState = _ref.setState,
        getState = _ref.getState,
        reducer = _ref.reducer;

    if (typeof fsa === 'function') {
        fsa(dispatch, getState);
    } else {
        (function () {
            var payload = fsa.payload,
                type = fsa.type;

            var thennable = null;

            if (payload && payload.then) {
                //payload is a promise
                thennable = payload;
            } else if (fsa.then) {
                thennable = fsa;
            }

            if (thennable) {
                thennable.then(function (resolvedPayload) {
                    return undefined.setState(function (prevState) {
                        return reducer(prevState, { type: type, payload: resolvedPayload });
                    });
                });
            } else {
                setState(function (prevState) {
                    return reducer(prevState, fsa);
                });
            }
        })();
    }
};

exports.default = withStore;