'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.NavGroup = undefined;

var _NavGroup$propTypes;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mergeStyles = require('../util/mergeStyles');

var _NavItem = require('./NavItem');

var _createNavItems = require('./createNavItems');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EXTRA_GROUP_STYLE = { padding: '10px 0px 0px 10px', margin: '0px -18px 0px -30px' };

var NavGroup = exports.NavGroup = function (_React$Component) {
    _inherits(NavGroup, _React$Component);

    function NavGroup(props) {
        _classCallCheck(this, NavGroup);

        var _this = _possibleConstructorReturn(this, (NavGroup.__proto__ || Object.getPrototypeOf(NavGroup)).call(this, props));

        _this.onClick = function () {
            _this.setState({ collapsed: !_this.state.collapsed });
        };

        _this.state = { collapsed: false, computedHeight: 0 };
        return _this;
    }

    _createClass(NavGroup, [{
        key: 'componentDidMount',
        value: function componentDidMount() {

            if (typeof document !== 'undefined') {
                var cloned = this.refs.cont.cloneNode(true);
                cloned.style.position = 'absolute';
                cloned.style.left = '-9999px';
                cloned.style.height = 'auto';
                document.body.appendChild(cloned);
                /* console.log(cloned, 'cloned height...', cloned.clientHeight); */
                this.setState({ computedHeight: cloned.clientHeight });
                document.body.removeChild(cloned);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _state = this.state,
                collapsed = _state.collapsed,
                height = _state.computedHeight;

            var style = (0, _mergeStyles.mergeStyles)((0, _mergeStyles.ternStyle)(collapsed, _extends({ height: height }, EXTRA_GROUP_STYLE), { height: 0 }));
            var _props = this.props,
                selectedId = _props.selectedId,
                onClick = _props.onClick,
                children = _props.children,
                highlightScheme = _props.highlightScheme,
                scheme = _props.scheme;


            return _react2.default.createElement(
                _NavItem.NavItem,
                { isGroupSection: true },
                _react2.default.createElement(
                    'ul',
                    { className: 'rui-snav' },
                    _react2.default.createElement(_NavItem.NavItem, { isGroupSection: true,
                        scheme: scheme, onClick: this.onClick, text: this.props.text,
                        icon: this.props.icon,
                        style: { padding: '0px 0px', borderLeft: 0 } })
                ),
                _react2.default.createElement(
                    'ul',
                    { ref: 'cont', style: style, className: 'rui-snav rui-snav-grp' },
                    (0, _createNavItems.createNavItems)({ children: children, onClick: onClick, highlightScheme: highlightScheme, scheme: scheme,
                        selectedId: selectedId, style: { paddingLeft: 24 } })
                )
            );
        }
    }]);

    return NavGroup;
}(_react2.default.Component);

NavGroup.propTypes = (_NavGroup$propTypes = {
    children: _react.PropTypes.node,
    selectedId: _react.PropTypes.string,
    onClick: _react.PropTypes.func,
    text: _react.PropTypes.string,
    icon: _react.PropTypes.string
}, _defineProperty(_NavGroup$propTypes, 'onClick', _react.PropTypes.func), _defineProperty(_NavGroup$propTypes, 'highlightScheme', _react.PropTypes.string), _defineProperty(_NavGroup$propTypes, 'scheme', _react.PropTypes.string), _NavGroup$propTypes);