'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SideNav = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Flex = require('../containers/Flex');

var _util = require('../util');

var _schemes = require('./schemes');

var _createNavItems = require('./createNavItems');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//export const DEFAULT_THEME = Object.freeze({ colors: { selection: '#f4f4f4', text: '#3a5266', highlight: '#c0392b' } });


/**
 * Side Bar Navigation component
 */
var SideNav = exports.SideNav = function (_React$Component) {
    _inherits(SideNav, _React$Component);

    function SideNav() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, SideNav);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SideNav.__proto__ || Object.getPrototypeOf(SideNav)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function (id) {
            var onClick = _this.props.onClick;

            onClick(id);
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(SideNav, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                children = _props.children,
                selectedId = _props.selectedId,
                scheme = _props.scheme,
                style = _props.style,
                highlightScheme = _props.highlightScheme;


            var containerClass = (0, _classnames2.default)({
                'rui-snav-clight': scheme === 'default',
                'rui-snav-cdark': scheme !== 'default'
            });
            /* console.log('selectedId ', highlightScheme, selectedId); */
            return _react2.default.createElement(
                _Flex.FlexColumn,
                { className: containerClass, style: _extends({ width: '100%', height: '100%' }, style) },
                _react2.default.createElement(
                    'ul',
                    { className: 'rui-snav' },
                    (0, _createNavItems.createNavItems)({ children: children, onClick: this.onClick, selectedId: selectedId, scheme: scheme, highlightScheme: highlightScheme })
                )
            );
        }
    }]);

    return SideNav;
}(_react2.default.Component);

SideNav.propTypes = {
    children: _react.PropTypes.node,
    scheme: _react.PropTypes.string,
    selectedId: _react.PropTypes.string.isRequired,
    onClick: _react.PropTypes.func,
    style: _react.PropTypes.object,
    highlightScheme: _react.PropTypes.oneOf(Object.keys(_schemes.SCHEMES))
};
SideNav.defaultProps = {
    onClick: _util.noop,
    scheme: 'default',
    style: {},
    highlightScheme: _schemes.SCHEMES.danger
};