'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.createNavItems = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _NavSection = require('./NavSection');

var _NavItem = require('./NavItem');

var _Nav = require('./Nav');

var _util = require('../util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var navItemCloner = function navItemCloner(_ref) {
    var onClick = _ref.onClick,
        selectedId = _ref.selectedId,
        style = _ref.style,
        highlightScheme = _ref.highlightScheme,
        scheme = _ref.scheme;
    return function (child) {
        return (0, _react.cloneElement)(child, { onClick: onClick, selectedId: selectedId, style: style, scheme: scheme, highlightScheme: highlightScheme });
    };
};

var createNavItems = exports.createNavItems = function createNavItems(_ref2) {
    var children = _ref2.children,
        onClick = _ref2.onClick,
        selectedId = _ref2.selectedId,
        _ref2$style = _ref2.style,
        style = _ref2$style === undefined ? {} : _ref2$style,
        highlightScheme = _ref2.highlightScheme,
        scheme = _ref2.scheme;

    var cloneNavItem = navItemCloner({ onClick: onClick, selectedId: selectedId, style: style, highlightScheme: highlightScheme, scheme: scheme });
    return _react.Children.map(children, function (child) {
        if (child.type === _NavSection.NavSection) {
            var grandC = child.props.children;
            var sectionE = _react2.default.createElement(
                _NavItem.NavItem,
                { selectedId: selectedId, onClick: _util.noop, scheme: scheme,
                    highlightScheme: highlightScheme },
                _react2.default.createElement(_Nav.SNav, child.props)
            );
            return [sectionE].concat(_toConsumableArray(_react.Children.map(grandC, cloneNavItem)));
        }
        return cloneNavItem(child);
    });
};