'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var isFalsy = function isFalsy(arg) {
    return arg === false || arg === undefined || arg === null || arg === 0 || arg === '';
};

var isTruthy = function isTruthy(arg) {
    return !isFalsy(arg);
};

var ternSingleArgCombinator = function ternSingleArgCombinator(f) {
    return function () {
        if (arguments.length === 1) {
            return arguments[0];
        }
        return f.apply(undefined, _toConsumableArray(Array.from(arguments)));
    };
};

var overrideStyles = exports.overrideStyles = function overrideStyles(base, override) {
    return Object.keys(base).reduce(function (result, key) {
        if (override[key]) {
            return _extends({}, result, _defineProperty({}, key, override[key]));
        }
        return _extends({}, result, _defineProperty({}, key, base[key]));
    }, {});
};

var ternStyle = exports.ternStyle = ternSingleArgCombinator(function (possiblePredicate, truthy, falsy) {
    return isFalsy(possiblePredicate) ? falsy : truthy;
});

var merge = function merge(styles, style) {
    return _extends({}, styles, style);
};

var mergeStyles = exports.mergeStyles = function mergeStyles() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
    }

    return args.filter(isTruthy).map(function (style) {
        var keys = Object.keys(style || {});
        return keys.reduce(function (accumulated, key) {
            if (style[key] !== undefined) {
                accumulated[key] = style[key];
            }
            return accumulated;
        }, {});
    }).reduce(merge, {});
};